
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Fan.vec"
	.INCLUDE "Fan.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2          "",  - ATmega8, 4MHz
;       3  . : Small,  SRAM - 0,   - 256
;       4 *****************************************************/
;       5 #include <mega8.h>
;       6 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       7 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       8 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;       9 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      10 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      11 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      12 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      13 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      14 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      15 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      16 	#endif
	#endif
;      17 #include <delay.h>
;      18 #include <stdlib.h>
;      19 //--------  LCD   ---------
;      20 #define RS PORTD.5  //0- , 1- 
;      21 #define E PORTD.4   //    
;      22 #define DB7 PORTD.0     // 4-  
;      23 #define DB6 PORTD.1
;      24 #define DB5 PORTD.2
;      25 #define DB4 PORTD.3
;      26 //----------------------------------------------------
;      27 #define led_time 6  //  . 
;      28 #pragma rl+                             // 
;      29 #define ADC_VREF_TYPE 0x40 // .  AVCC
;      30 //====================================================
;      31 //                   
;      32 //====================================================
;      33 void lcd(unsigned char d)
;      34  {E=1;

	.CSEG
_lcd:
;	d -> Y+0
	SBI  0x12,4
;      35   DB7=(d&0x80)>>7;            //  
	LD   R30,Y
	ANDI R30,LOW(0x80)
	ROL  R30
	LDI  R30,0
	ROL  R30
	CPI  R30,0
	BRNE _0x5
	CBI  0x12,0
	RJMP _0x6
_0x5:
	SBI  0x12,0
_0x6:
;      36   DB6=(d&0x40)>>6;
	LD   R30,Y
	ANDI R30,LOW(0x40)
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	CPI  R30,0
	BRNE _0x7
	CBI  0x12,1
	RJMP _0x8
_0x7:
	SBI  0x12,1
_0x8:
;      37   DB5=(d&0x20)>>5;
	LD   R30,Y
	ANDI R30,LOW(0x20)
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	CPI  R30,0
	BRNE _0x9
	CBI  0x12,2
	RJMP _0xA
_0x9:
	SBI  0x12,2
_0xA:
;      38   DB4=(d&0x10)>>4;
	LD   R30,Y
	ANDI R30,LOW(0x10)
	SWAP R30
	ANDI R30,0xF
	CPI  R30,0
	BRNE _0xB
	CBI  0x12,3
	RJMP _0xC
_0xB:
	SBI  0x12,3
_0xC:
;      39   delay_us(165);                            //
	RCALL SUBOPT_0x0
;      40   E=0;                                        //
	CBI  0x12,4
;      41   delay_us(165);                            //
	RCALL SUBOPT_0x0
;      42   E=1;                                    //enable = 1
	SBI  0x12,4
;      43   DB7=(d&0x08)>>3;             //  
	LD   R30,Y
	ANDI R30,LOW(0x8)
	LSR  R30
	LSR  R30
	LSR  R30
	CPI  R30,0
	BRNE _0x11
	CBI  0x12,0
	RJMP _0x12
_0x11:
	SBI  0x12,0
_0x12:
;      44   DB6=(d&0x04)>>2;
	LD   R30,Y
	ANDI R30,LOW(0x4)
	LSR  R30
	LSR  R30
	CPI  R30,0
	BRNE _0x13
	CBI  0x12,1
	RJMP _0x14
_0x13:
	SBI  0x12,1
_0x14:
;      45   DB5=(d&0x02)>>1;
	LD   R30,Y
	ANDI R30,LOW(0x2)
	LSR  R30
	CPI  R30,0
	BRNE _0x15
	CBI  0x12,2
	RJMP _0x16
_0x15:
	SBI  0x12,2
_0x16:
;      46   DB4=(d&0x01);
	LD   R30,Y
	ANDI R30,LOW(0x1)
	BRNE _0x17
	CBI  0x12,3
	RJMP _0x18
_0x17:
	SBI  0x12,3
_0x18:
;      47   delay_us(165);                            //
	RCALL SUBOPT_0x0
;      48   E=0;                                        //
	CBI  0x12,4
;      49   delay_us(825);}       //   
	RCALL SUBOPT_0x1
	RJMP _0x51
;      50 //====================================================
;      51 //              
;      52 //====================================================
;      53 void lcd_com(unsigned char c)
;      54 {RS=0;                           //  
_lcd_com:
;	c -> Y+0
	CBI  0x12,5
;      55  lcd(c);}                                     //
	LD   R30,Y
	ST   -Y,R30
	RCALL _lcd
	RJMP _0x51
;      56 //====================================================
;      57 //              
;      58 //====================================================
;      59 void lcd_putchar(unsigned char d)
;      60  {RS=1;                          //  
_lcd_putchar:
;	d -> Y+0
	SBI  0x12,5
;      61   lcd(d);}                                    //
	LD   R30,Y
	ST   -Y,R30
	RCALL _lcd
	RJMP _0x51
;      62 //====================================================
;      63 //                
;      64 //====================================================
;      65 void lcd_clear(void)
;      66 {lcd_com(0x01); delay_ms(165);}          // 
_lcd_clear:
	RCALL SUBOPT_0x2
	RCALL _lcd_com
	LDI  R30,LOW(165)
	LDI  R31,HIGH(165)
	RCALL SUBOPT_0x3
	RET
;      67 //====================================================
;      68 //             
;      69 //====================================================
;      70 void lcd_init(void)
;      71 {delay_ms(17);              // 
_lcd_init:
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	RCALL SUBOPT_0x3
;      72  lcd_com(0x33); delay_ms(82);             //
	LDI  R30,LOW(51)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(82)
	LDI  R31,HIGH(82)
	RCALL SUBOPT_0x3
;      73  lcd_com(0x32); lcd_com(0x28);      //4 , 2 
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x4
;      74  lcd_com(0x08);                       // 
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x4
;      75  lcd_clear();                            // 
	RCALL _lcd_clear
;      76  lcd_com(0x06);                 //  
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x4
;      77  lcd_com(0x0C);                //  
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x4
;      78  delay_us(825);}        //   
	RCALL SUBOPT_0x1
	RET
;      79 //====================================================
;      80 //             
;      81 //====================================================
;      82 void lcd_puts(unsigned char *str)
;      83 {unsigned char i;
_lcd_puts:
;      84  while (i=*str++) lcd_putchar(i);}
	ST   -Y,R17
;	*str -> Y+1
;	i -> R17
_0x1F:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x21
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x1F
_0x21:
	LDD  R17,Y+0
	RJMP _0x52
;      85 //====================================================
;      86 //             FLASH
;      87 //====================================================
;      88 void lcd_putsf(char flash *str)
;      89 {unsigned char i;
_lcd_putsf:
;      90 while (i=*str++) lcd_putchar(i);}
	ST   -Y,R17
;	*str -> Y+1
;	i -> R17
_0x22:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x24
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x22
_0x24:
	LDD  R17,Y+0
_0x52:
	ADIW R28,3
	RET
;      91 //====================================================
;      92 //           
;      93 //====================================================
;      94 void lcd_gotoxy(unsigned char x, unsigned char y)
;      95 {    // .  080 - . . 
_lcd_gotoxy:
;      96  lcd_com((0x80+y*64)+x); }
;	x -> Y+1
;	y -> Y+0
	LD   R30,Y
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	SUBI R30,-LOW(128)
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x4
	ADIW R28,2
	RET
;      97 //====================================================
;      98 //       
;      99 //====================================================
;     100 unsigned int read_adc(unsigned char adc_input) {
_read_adc:
;     101 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);// 
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
;     102 delay_us(10);        //  . 
	__DELAY_USB 13
;     103 ADCSRA|=0x40;                   // 
	SBI  0x6,6
;     104 while ((ADCSRA & 0x10)==0);//  
_0x25:
	SBIS 0x6,4
	RJMP _0x25
;     105 ADCSRA|=0x10;           //
	SBI  0x6,4
;     106 return ADCW;}                     // 
	IN   R30,0x4
	IN   R31,0x4+1
_0x51:
	ADIW R28,1
	RET
;     107 //====================================================
;     108 //                 
;     109 //====================================================
;     110 void snd(void) {
_snd:
;     111 unsigned char i;
;     112 for (i=0;i<250;i++){PORTC.2=~PINC.2; delay_us(300);}
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x29:
	CPI  R17,250
	BRSH _0x2A
	SBIS 0x13,2
	RJMP _0x2B
	CBI  0x15,2
	RJMP _0x2C
_0x2B:
	SBI  0x15,2
_0x2C:
	__DELAY_USW 300
	SUBI R17,-1
	RJMP _0x29
_0x2A:
;     113 }
	LD   R17,Y+
	RET
;     114 //====================================================
;     115 //                   
;     116 //====================================================
;     117 void main(void){
_main:
;     118 unsigned int adc_t, adc_r;  //  .
;     119 static float t,old_t,pwm,old_pwm;  //  %

	.DSEG
_t_SA:
	.BYTE 0x4
_old_t_SA:
	.BYTE 0x4
_pwm_SA:
	.BYTE 0x4
_old_pwm_SA:
	.BYTE 0x4

	.CSEG
;     120 static unsigned char mode, old_mode, lcd_led_time;

	.DSEG

	.CSEG
;     121 char tmp_str[2];
;     122 // 0-2   -    
;     123 // 0 - , 1-Fan1, 2-Fan2, 3-
;     124 PORTB=0x00; DDRB=0x0B;
	SBIW R28,2
;	adc_t -> R16,R17
;	adc_r -> R18,R19
;	tmp_str -> Y+0
	LDI  R30,LOW(0)
	OUT  0x18,R30
	LDI  R30,LOW(11)
	OUT  0x17,R30
;     125 //PC2  
;     126 PORTC=0x00; DDRC=0x04;
	LDI  R30,LOW(0)
	OUT  0x15,R30
	LDI  R30,LOW(4)
	OUT  0x14,R30
;     127 // 0-5  D -    
;     128 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     129 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     130 //========= Timer/Counter 1==============
;     131 TCCR1A=0x81;       //Phase Correct Pwm,  top 00FF .
	LDI  R30,LOW(129)
	OUT  0x2F,R30
;     132 TCCR1B=0x04;//  - . (15625)
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     133 TCNT1H=0x00; TCNT1L=0x00;               //  
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
;     134 OCR1AH=0x00; OCR1AL=0x80;               // Fan1 50%
	OUT  0x2B,R30
	LDI  R30,LOW(128)
	OUT  0x2A,R30
;     135 //========= Timer/Counter 2==============
;     136 ASSR=0x00;         //Phase Correct Pwm,  top 00FF .
	LDI  R30,LOW(0)
	OUT  0x22,R30
;     137 TCCR2=0x62; //  - .  (500)
	LDI  R30,LOW(98)
	OUT  0x25,R30
;     138 TCNT2=0x00; OCR2=0xC0;                        //75%
	LDI  R30,LOW(0)
	OUT  0x24,R30
	LDI  R30,LOW(192)
	OUT  0x23,R30
;     139 //===========  =================
;     140 // 1000 kHz,   AVCC,10  
;     141 ADMUX=ADC_VREF_TYPE & 0xff; ADCSRA=0x82;
	LDI  R30,LOW(64)
	OUT  0x7,R30
	LDI  R30,LOW(130)
	OUT  0x6,R30
;     142 //=============== ====================
;     143 lcd_init();                            //
	RCALL _lcd_init
;     144 lcd_gotoxy(2,0);  lcd_putsf("");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	__POINTW1FN _0,0
	RCALL SUBOPT_0x7
;     145 lcd_gotoxy(9,0);  lcd_putsf("t=0");
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL SUBOPT_0x6
	__POINTW1FN _0,5
	RCALL SUBOPT_0x7
;     146 lcd_gotoxy(2,1);  lcd_putsf("=0%");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
	__POINTW1FN _0,10
	RCALL SUBOPT_0x7
;     147 old_mode=0; old_t=0; old_pwm=0;
	CLR  R4
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xA
;     148 //================ ======================
;     149 snd();                               // 
	RCALL _snd
;     150 lcd_led_time=led_time;       //  LCD
	LDI  R30,LOW(6)
	MOV  R7,R30
;     151 OCR2=0;
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     152 //===========  ================
;     153 while (1){     //   
_0x2D:
;     154 adc_t=read_adc(3);              // 
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R16,R30
;     155  // .  5   8 8- 
;     156 adc_r=read_adc(5)>>2;   //    2
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _read_adc
	RCALL __LSRW2
	MOVW R18,R30
;     157 if (adc_r==0) {mode=0;}//  
	MOV  R0,R18
	OR   R0,R19
	BRNE _0x30
	CLR  R5
;     158   else {mode=1;};         //0-, 1-
	RJMP _0x31
_0x30:
	LDI  R30,LOW(1)
	MOV  R5,R30
_0x31:
;     159 if (mode==0) {      //   
	TST  R5
	BRNE _0x32
;     160  if (adc_t>641) {  //   40 
	__CPWRN 16,17,642
	BRLO _0x33
;     161   OCR1AL=255;}                              // 100%
	LDI  R30,LOW(255)
	RJMP _0x53
;     162  else {
_0x33:
;     163   if (adc_t<610) { //   25 
	__CPWRN 16,17,610
	BRSH _0x35
;     164    OCR1A=0;}                                  // 0%
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     165   else {                //   25  40
	RJMP _0x36
_0x35:
;     166   OCR1AL=128+(adc_t-610)*4.065;}}}        // 
	MOVW R30,R16
	SUBI R30,LOW(610)
	SBCI R31,HIGH(610)
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x4082147B
	RCALL __MULF12
	__GETD2N 0x43000000
	RCALL __ADDF12
	RCALL __CFD1U
_0x53:
	OUT  0x2A,R30
_0x36:
;     167 else {                 //   
	RJMP _0x37
_0x32:
;     168  OCR1AL=128+adc_r/2;                      // 
	MOVW R30,R18
	LSR  R31
	ROR  R30
	SUBI R30,LOW(-128)
	SBCI R31,HIGH(-128)
	OUT  0x2A,R30
;     169 };
_0x37:
;     170 //------------   ---------
;     171 if (mode!=old_mode) {
	CP   R4,R5
	BREQ _0x38
;     172 if (mode==1) {        //  
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x39
;     173  lcd_gotoxy(2,0);  lcd_putsf("");}
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	__POINTW1FN _0,21
	RJMP _0x54
;     174  else {lcd_gotoxy(2,0);  lcd_putsf("");}
_0x39:
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	__POINTW1FN _0,0
_0x54:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
;     175  lcd_led_time=led_time;       //  LCD
	RCALL SUBOPT_0xB
;     176  OCR2=0xC0;
;     177  old_mode=mode;
	MOV  R4,R5
;     178 };
_0x38:
;     179 //-------------  ------------
;     180 t=adc_t;               //   
	MOVW R30,R16
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL SUBOPT_0xC
;     181 t=t*500/1023-273;
	RCALL SUBOPT_0xD
	__GETD1N 0x43FA0000
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x447FC000
	RCALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x43888000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0xC
;     182 if (t!=old_t) {
	LDS  R30,_old_t_SA
	LDS  R31,_old_t_SA+1
	LDS  R22,_old_t_SA+2
	LDS  R23,_old_t_SA+3
	RCALL SUBOPT_0xD
	RCALL __CPD12
	BREQ _0x3B
;     183 ftoa(t,0,tmp_str);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
;     184 lcd_gotoxy(11,0); lcd_putsf("    ");       // 
	LDI  R30,LOW(11)
	ST   -Y,R30
	RCALL SUBOPT_0x6
	__POINTW1FN _0,26
	RCALL SUBOPT_0x7
;     185 lcd_gotoxy(11,0); lcd_puts(tmp_str); lcd_putsf("C");
	LDI  R30,LOW(11)
	ST   -Y,R30
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x10
	__POINTW1FN _0,8
	RCALL SUBOPT_0x7
;     186 old_t=t;
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x9
;     187 };
_0x3B:
;     188 //-------------  ---------------------
;     189 pwm=OCR1AL; pwm=pwm*0.392;     //   %%
	IN   R30,0x2A
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	__GETD1N 0x3EC8B439
	RCALL __MULF12
	RCALL SUBOPT_0x12
;     190 if (pwm!=old_pwm) {
	LDS  R30,_old_pwm_SA
	LDS  R31,_old_pwm_SA+1
	LDS  R22,_old_pwm_SA+2
	LDS  R23,_old_pwm_SA+3
	RCALL SUBOPT_0x13
	RCALL __CPD12
	BREQ _0x3C
;     191 ftoa(pwm,0,tmp_str);  //     %
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xF
;     192 lcd_gotoxy(10,1); lcd_putsf("    ");
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
	__POINTW1FN _0,26
	RCALL SUBOPT_0x7
;     193 lcd_gotoxy(10,1); lcd_puts(tmp_str); lcd_putsf("%");
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
	RCALL SUBOPT_0x10
	__POINTW1FN _0,19
	RCALL SUBOPT_0x7
;     194 old_pwm=pwm;
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xA
;     195 if (mode==1) {         //   
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x3D
;     196  lcd_led_time=led_time;       //  LCD
	RCALL SUBOPT_0xB
;     197  OCR2=0xC0;}
;     198 }
_0x3D:
;     199 if (adc_r>661){    //   50 
_0x3C:
	__CPWRN 18,19,662
	BRLO _0x3E
;     200 snd();}                     //  
	RCALL _snd
;     201 delay_ms(500);
_0x3E:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x3
;     202 if (lcd_led_time!=0) {   //   LCD
	TST  R7
	BREQ _0x3F
;     203  lcd_led_time--;
	DEC  R7
;     204  if (lcd_led_time==0) {   //  
	TST  R7
	BRNE _0x40
;     205     OCR2=0;}              //lcd_time 
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     206  }
_0x40:
;     207 }
_0x3F:
	RJMP _0x2D
;     208 }//================ ====================
_0x41:
	RJMP _0x41

_ftoa:
	SBIW R28,4
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x15
	RCALL __CPD20
	BRGE _0x42
	RCALL SUBOPT_0x16
	RCALL __ANEGF1
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	LDI  R30,LOW(45)
	ST   X,R30
_0x42:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x43
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x43:
	LDD  R30,Y+8
	LDI  R26,LOW(__fround_G2*2)
	LDI  R27,HIGH(__fround_G2*2)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	RCALL __GETD1PF
	RCALL SUBOPT_0x15
	RCALL __ADDF12
	RCALL SUBOPT_0x17
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	RCALL SUBOPT_0x19
_0x44:
	RCALL SUBOPT_0x1A
	RCALL __CMPF12
	BRLO _0x46
	RCALL SUBOPT_0x1B
	RCALL __MULF12
	RCALL SUBOPT_0x19
	SUBI R17,-LOW(1)
	RJMP _0x44
_0x46:
	CPI  R17,0
	BRNE _0x47
	RCALL SUBOPT_0x18
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x48
_0x47:
_0x49:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x4B
	RCALL SUBOPT_0x1B
	RCALL __DIVF21
	__GETD2N 0x3F000000
	RCALL __ADDF12
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL __DIVF21
	RCALL __CFD1
	MOV  R16,R30
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1C
	__GETD2S 2
	RCALL SUBOPT_0x11
	RCALL __MULF12
	RCALL SUBOPT_0x15
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x17
	RJMP _0x49
_0x4B:
_0x48:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x4C
	RCALL SUBOPT_0x1D
	RJMP _0x50
_0x4C:
	RCALL SUBOPT_0x18
	LDI  R30,LOW(46)
	ST   X,R30
_0x4D:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x4F
	RCALL SUBOPT_0x15
	__GETD1N 0x41200000
	RCALL __MULF12
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x16
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x11
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x17
	RJMP _0x4D
_0x4F:
	RCALL SUBOPT_0x1D
_0x50:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	__DELAY_USB 220
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	__DELAY_USW 825
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	RJMP _lcd_com

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	__GETD1N 0x0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	STS  _old_t_SA,R30
	STS  _old_t_SA+1,R31
	STS  _old_t_SA+2,R22
	STS  _old_t_SA+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	STS  _old_pwm_SA,R30
	STS  _old_pwm_SA+1,R31
	STS  _old_pwm_SA+2,R22
	STS  _old_pwm_SA+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(6)
	MOV  R7,R30
	LDI  R30,LOW(192)
	OUT  0x23,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC:
	STS  _t_SA,R30
	STS  _t_SA+1,R31
	STS  _t_SA+2,R22
	STS  _t_SA+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDS  R26,_t_SA
	LDS  R27,_t_SA+1
	LDS  R24,_t_SA+2
	LDS  R25,_t_SA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	LDS  R30,_t_SA
	LDS  R31,_t_SA+1
	LDS  R22,_t_SA+2
	LDS  R23,_t_SA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF:
	RCALL __PUTPARD1
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	STS  _pwm_SA,R30
	STS  _pwm_SA+1,R31
	STS  _pwm_SA+2,R22
	STS  _pwm_SA+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	LDS  R26,_pwm_SA
	LDS  R27,_pwm_SA+1
	LDS  R24,_pwm_SA+2
	LDS  R25,_pwm_SA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	LDS  R30,_pwm_SA
	LDS  R31,_pwm_SA+1
	LDS  R22,_pwm_SA+2
	LDS  R23,_pwm_SA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x15:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	__GETD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x17:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x18:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	__GETD1S 2
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	__GETD2S 2
	__GETD1N 0x41200000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
