/*****************************************************
         "",  - ATmega8, 4MHz 
 . : Small,  SRAM - 0,   - 256
*****************************************************/
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+
#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


//--------  LCD   ---------
//----------------------------------------------------
#pragma rl+                             // 
//====================================================
//                   
//====================================================
void lcd(unsigned char d)
 {PORTD.4   =1;   
  PORTD.0     =(d&0x80)>>7;            //  
  PORTD.1=(d&0x40)>>6;
  PORTD.2=(d&0x20)>>5;
  PORTD.3=(d&0x10)>>4;
  delay_us(165);                            //
  PORTD.4   =0;                                        //
  delay_us(165);                            //
  PORTD.4   =1;                                    //enable = 1
  PORTD.0     =(d&0x08)>>3;             //  
  PORTD.1=(d&0x04)>>2; 
  PORTD.2=(d&0x02)>>1; 
  PORTD.3=(d&0x01); 
  delay_us(165);                            //    
  PORTD.4   =0;                                        //
  delay_us(825);}       //   
//====================================================  
//              
//====================================================
void lcd_com(unsigned char c)
{PORTD.5  =0;                           //  
 lcd(c);}                                     //
//====================================================
//              
//====================================================
void lcd_putchar(unsigned char d)
 {PORTD.5  =1;                          //  
  lcd(d);}                                    //
//====================================================
//                
//====================================================
void lcd_clear(void)
{lcd_com(0x01); delay_ms(165);}          // 
//====================================================
//             
//====================================================
void lcd_init(void)
{delay_ms(17);              // 
 lcd_com(0x33); delay_ms(82);             //
 lcd_com(0x32); lcd_com(0x28);      //4 , 2 
 lcd_com(0x08);                       // 
 lcd_clear();                            // 
 lcd_com(0x06);                 //  
 lcd_com(0x0C);                //  
 delay_us(825);}        //       
//====================================================
//             
//====================================================
void lcd_puts(unsigned char *str)
{unsigned char i;
 while (i=*str++) lcd_putchar(i);}
//==================================================== 
//             FLASH
//====================================================
void lcd_putsf(char flash *str)
{unsigned char i;
while (i=*str++) lcd_putchar(i);}
//====================================================
//           
//====================================================
void lcd_gotoxy(unsigned char x, unsigned char y)
{    // .  080 - . . 
 lcd_com((0x80+y*64)+x); }    
//====================================================
//       
//====================================================
unsigned int read_adc(unsigned char adc_input) {
ADMUX=adc_input | (0x40  & 0xff);// 
delay_us(10);        //  . 
ADCSRA|=0x40;                   // 
while ((ADCSRA & 0x10)==0);//  
ADCSRA|=0x10;           //
return ADCW;}                     // 
//====================================================
//                 
//====================================================
void snd(void) {
unsigned char i;
for (i=0;i<250;i++){PORTC.2=~PINC.2; delay_us(300);}
}
//====================================================
//                   
//====================================================
void main(void){
unsigned int adc_t, adc_r;  //  .
static float t,old_t,pwm,old_pwm;  //  %
static unsigned char mode, old_mode, lcd_led_time;
char tmp_str[2];
// 0-2   -    
// 0 - , 1-Fan1, 2-Fan2, 3-
PORTB=0x00; DDRB=0x0B;
//PC2  
PORTC=0x00; DDRC=0x04;
// 0-5  D -    
PORTD=0x00;
DDRD=0xFF;
//========= Timer/Counter 1==============
TCCR1A=0x81;       //Phase Correct Pwm,  top 00FF . 
TCCR1B=0x04;//  - . (15625)
TCNT1H=0x00; TCNT1L=0x00;               //  
OCR1AH=0x00; OCR1AL=0x80;               // Fan1 50%
//========= Timer/Counter 2==============
ASSR=0x00;         //Phase Correct Pwm,  top 00FF .
TCCR2=0x62; //  - .  (500)
TCNT2=0x00; OCR2=0xC0;                        //75% 
//===========  =================
// 1000 kHz,   AVCC,10  
ADMUX=0x40  & 0xff; ADCSRA=0x82; 
//=============== ====================
lcd_init();                            //
lcd_gotoxy(2,0);  lcd_putsf("");
lcd_gotoxy(9,0);  lcd_putsf("t=0");
lcd_gotoxy(2,1);  lcd_putsf("=0%");
old_mode=0; old_t=0; old_pwm=0;
//================ ======================
snd();                               // 
lcd_led_time=6  ;       //  LCD
OCR2=0;  
//===========  ================
while (1){     //   
adc_t=read_adc(3);              // 
 // .  5   8 8- 
adc_r=read_adc(5)>>2;   //    2
if (adc_r==0) {mode=0;}//  
  else {mode=1;};         //0-, 1-
if (mode==0) {      //         
 if (adc_t>641) {  //   40 
  OCR1AL=255;}                              // 100%
 else {            
  if (adc_t<610) { //   25 
   OCR1A=0;}                                  // 0%
  else {                //   25  40 
  OCR1AL=128+(adc_t-610)*4.065;}}}        // 
else {                 //   
 OCR1AL=128+adc_r/2;                      // 
}; 
//------------   ---------
if (mode!=old_mode) {  
if (mode==1) {        //  
 lcd_gotoxy(2,0);  lcd_putsf("");}
 else {lcd_gotoxy(2,0);  lcd_putsf("");}
 lcd_led_time=6  ;       //  LCD
 OCR2=0xC0;
 old_mode=mode;
};
//-------------  ------------
t=adc_t;               //   
t=t*500/1023-273;    
if (t!=old_t) {          
ftoa(t,0,tmp_str);
lcd_gotoxy(11,0); lcd_putsf("    ");       // 
lcd_gotoxy(11,0); lcd_puts(tmp_str); lcd_putsf("C");
old_t=t;
};
//-------------  ---------------------
pwm=OCR1AL; pwm=pwm*0.392;     //   %% 
if (pwm!=old_pwm) {
ftoa(pwm,0,tmp_str);  //     %  
lcd_gotoxy(10,1); lcd_putsf("    "); 
lcd_gotoxy(10,1); lcd_puts(tmp_str); lcd_putsf("%");
old_pwm=pwm;
if (mode==1) {         //    
 lcd_led_time=6  ;       //  LCD
 OCR2=0xC0;} 
}
if (adc_r>661){    //   50 
snd();}                     //  
delay_ms(500);
if (lcd_led_time!=0) {   //   LCD
 lcd_led_time--;
 if (lcd_led_time==0) {   //  
    OCR2=0;}              //lcd_time 
 } 
}
}//================ ====================
