/*****************************************************
         "",  - ATmega8, 4MHz 
 . : Small,  SRAM - 0,   - 256
*****************************************************/
#include <mega8.h>
#include <delay.h> 
#include <stdlib.h>
//--------  LCD   ---------
#define RS PORTD.5  //0- , 1- 
#define E PORTD.4   //    
#define DB7 PORTD.0     // 4-  
#define DB6 PORTD.1
#define DB5 PORTD.2
#define DB4 PORTD.3
//----------------------------------------------------
#define led_time 6  //  . 
#pragma rl+                             // 
#define ADC_VREF_TYPE 0x40 // .  AVCC
//====================================================
//                   
//====================================================
void lcd(unsigned char d)
 {E=1;   
  DB7=(d&0x80)>>7;            //  
  DB6=(d&0x40)>>6;
  DB5=(d&0x20)>>5;
  DB4=(d&0x10)>>4;
  delay_us(165);                            //
  E=0;                                        //
  delay_us(165);                            //
  E=1;                                    //enable = 1
  DB7=(d&0x08)>>3;             //  
  DB6=(d&0x04)>>2; 
  DB5=(d&0x02)>>1; 
  DB4=(d&0x01); 
  delay_us(165);                            //    
  E=0;                                        //
  delay_us(825);}       //   
//====================================================  
//              
//====================================================
void lcd_com(unsigned char c)
{RS=0;                           //  
 lcd(c);}                                     //
//====================================================
//              
//====================================================
void lcd_putchar(unsigned char d)
 {RS=1;                          //  
  lcd(d);}                                    //
//====================================================
//                
//====================================================
void lcd_clear(void)
{lcd_com(0x01); delay_ms(165);}          // 
//====================================================
//             
//====================================================
void lcd_init(void)
{delay_ms(17);              // 
 lcd_com(0x33); delay_ms(82);             //
 lcd_com(0x32); lcd_com(0x28);      //4 , 2 
 lcd_com(0x08);                       // 
 lcd_clear();                            // 
 lcd_com(0x06);                 //  
 lcd_com(0x0C);                //  
 delay_us(825);}        //       
//====================================================
//             
//====================================================
void lcd_puts(unsigned char *str)
{unsigned char i;
 while (i=*str++) lcd_putchar(i);}
//==================================================== 
//             FLASH
//====================================================
void lcd_putsf(char flash *str)
{unsigned char i;
while (i=*str++) lcd_putchar(i);}
//====================================================
//           
//====================================================
void lcd_gotoxy(unsigned char x, unsigned char y)
{    // .  080 - . . 
 lcd_com((0x80+y*64)+x); }    
//====================================================
//       
//====================================================
unsigned int read_adc(unsigned char adc_input) {
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);// 
delay_us(10);        //  . 
ADCSRA|=0x40;                   // 
while ((ADCSRA & 0x10)==0);//  
ADCSRA|=0x10;           //
return ADCW;}                     // 
//====================================================
//                 
//====================================================
void snd(void) {
unsigned char i;
for (i=0;i<250;i++){PORTC.2=~PINC.2; delay_us(300);}
}
//====================================================
//                   
//====================================================
void main(void){
unsigned int adc_t, adc_r;  //  .
static float t,old_t,pwm,old_pwm;  //  %
static unsigned char mode, old_mode, lcd_led_time;
char tmp_str[2];
// 0-2   -    
// 0 - , 1-Fan1, 2-Fan2, 3-
PORTB=0x00; DDRB=0x0B;
//PC2  
PORTC=0x00; DDRC=0x04;
// 0-5  D -    
PORTD=0x00;
DDRD=0xFF;
//========= Timer/Counter 1==============
TCCR1A=0x81;       //Phase Correct Pwm,  top 00FF . 
TCCR1B=0x04;//  - . (15625)
TCNT1H=0x00; TCNT1L=0x00;               //  
OCR1AH=0x00; OCR1AL=0x80;               // Fan1 50%
//========= Timer/Counter 2==============
ASSR=0x00;         //Phase Correct Pwm,  top 00FF .
TCCR2=0x62; //  - .  (500)
TCNT2=0x00; OCR2=0xC0;                        //75% 
//===========  =================
// 1000 kHz,   AVCC,10  
ADMUX=ADC_VREF_TYPE & 0xff; ADCSRA=0x82; 
//=============== ====================
lcd_init();                            //
lcd_gotoxy(2,0);  lcd_putsf("");
lcd_gotoxy(9,0);  lcd_putsf("t=0");
lcd_gotoxy(2,1);  lcd_putsf("=0%");
old_mode=0; old_t=0; old_pwm=0;
//================ ======================
snd();                               // 
lcd_led_time=led_time;       //  LCD
OCR2=0;  
//===========  ================
while (1){     //   
adc_t=read_adc(3);              // 
 // .  5   8 8- 
adc_r=read_adc(5)>>2;   //    2
if (adc_r==0) {mode=0;}//  
  else {mode=1;};         //0-, 1-
if (mode==0) {      //         
 if (adc_t>641) {  //   40 
  OCR1AL=255;}                              // 100%
 else {            
  if (adc_t<610) { //   25 
   OCR1A=0;}                                  // 0%
  else {                //   25  40 
  OCR1AL=128+(adc_t-610)*4.065;}}}        // 
else {                 //   
 OCR1AL=128+adc_r/2;                      // 
}; 
//------------   ---------
if (mode!=old_mode) {  
if (mode==1) {        //  
 lcd_gotoxy(2,0);  lcd_putsf("");}
 else {lcd_gotoxy(2,0);  lcd_putsf("");}
 lcd_led_time=led_time;       //  LCD
 OCR2=0xC0;
 old_mode=mode;
};
//-------------  ------------
t=adc_t;               //   
t=t*500/1023-273;    
if (t!=old_t) {          
ftoa(t,0,tmp_str);
lcd_gotoxy(11,0); lcd_putsf("    ");       // 
lcd_gotoxy(11,0); lcd_puts(tmp_str); lcd_putsf("C");
old_t=t;
};
//-------------  ---------------------
pwm=OCR1AL; pwm=pwm*0.392;     //   %% 
if (pwm!=old_pwm) {
ftoa(pwm,0,tmp_str);  //     %  
lcd_gotoxy(10,1); lcd_putsf("    "); 
lcd_gotoxy(10,1); lcd_puts(tmp_str); lcd_putsf("%");
old_pwm=pwm;
if (mode==1) {         //    
 lcd_led_time=led_time;       //  LCD
 OCR2=0xC0;} 
}
if (adc_r>661){    //   50 
snd();}                     //  
delay_ms(500);
if (lcd_led_time!=0) {   //   LCD
 lcd_led_time--;
 if (lcd_led_time==0) {   //  
    OCR2=0;}              //lcd_time 
 } 
}
}//================ ====================
